using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Vis_TelAllot
	/// </summary>
	public partial class T_Vis_TelAllot
    {
        public T_Vis_TelAllot()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_AllotID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Vis_TelAllot");
            strSql.Append(" where F_AllotID=@F_AllotID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AllotID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_AllotID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Vis_TelAllot model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Vis_TelAllot(");
            strSql.Append("F_AllotUserID,F_AllotUserName,F_AllotZXID,F_AllotZXName,F_HFTelID,F_state,F_CreateUserID,F_CreateUserName,F_CreateDate)");
            strSql.Append(" values (");
            strSql.Append("@F_AllotUserID,@F_AllotUserName,@F_AllotZXID,@F_AllotZXName,@F_HFTelID,@F_state,@F_CreateUserID,@F_CreateUserName,@F_CreateDate)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AllotUserID", SqlDbType.Int,4),
                    new SqlParameter("@F_AllotUserName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AllotZXID", SqlDbType.Int,4),
                    new SqlParameter("@F_AllotZXName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_HFTelID", SqlDbType.Int,4),
                    new SqlParameter("@F_state", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUserID", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUserName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime)};
            parameters[0].Value = model.F_AllotUserID;
            parameters[1].Value = model.F_AllotUserName;
            parameters[2].Value = model.F_AllotZXID;
            parameters[3].Value = model.F_AllotZXName;
            parameters[4].Value = model.F_HFTelID;
            parameters[5].Value = model.F_state;
            parameters[6].Value = model.F_CreateUserID;
            parameters[7].Value = model.F_CreateUserName;
            parameters[8].Value = model.F_CreateDate;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Vis_TelAllot model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Vis_TelAllot set ");
            strSql.Append("F_AllotUserID=@F_AllotUserID,");
            strSql.Append("F_AllotUserName=@F_AllotUserName,");
            strSql.Append("F_AllotZXID=@F_AllotZXID,");
            strSql.Append("F_AllotZXName=@F_AllotZXName,");
            strSql.Append("F_HFTelID=@F_HFTelID,");
            strSql.Append("F_state=@F_state,");
            strSql.Append("F_CreateUserID=@F_CreateUserID,");
            strSql.Append("F_CreateUserName=@F_CreateUserName,");
            strSql.Append("F_CreateDate=@F_CreateDate");
            strSql.Append(" where F_AllotID=@F_AllotID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AllotUserID", SqlDbType.Int,4),
                    new SqlParameter("@F_AllotUserName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AllotZXID", SqlDbType.Int,4),
                    new SqlParameter("@F_AllotZXName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_HFTelID", SqlDbType.Int,4),
                    new SqlParameter("@F_state", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUserID", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUserName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@F_AllotID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_AllotUserID;
            parameters[1].Value = model.F_AllotUserName;
            parameters[2].Value = model.F_AllotZXID;
            parameters[3].Value = model.F_AllotZXName;
            parameters[4].Value = model.F_HFTelID;
            parameters[5].Value = model.F_state;
            parameters[6].Value = model.F_CreateUserID;
            parameters[7].Value = model.F_CreateUserName;
            parameters[8].Value = model.F_CreateDate;
            parameters[9].Value = model.F_AllotID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_AllotID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Vis_TelAllot ");
            strSql.Append(" where F_AllotID=@F_AllotID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AllotID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_AllotID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_AllotIDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Vis_TelAllot ");
            strSql.Append(" where F_AllotID in (" + F_AllotIDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Vis_TelAllot GetModel(int F_AllotID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_AllotID,F_AllotUserID,F_AllotUserName,F_AllotZXID,F_AllotZXName,F_HFTelID,F_state,F_CreateUserID,F_CreateUserName,F_CreateDate from T_Vis_TelAllot ");
            strSql.Append(" where F_AllotID=@F_AllotID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AllotID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_AllotID;

            Model.T_Vis_TelAllot model = new Model.T_Vis_TelAllot();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Vis_TelAllot DataRowToModel(DataRow row)
        {
            Model.T_Vis_TelAllot model = new Model.T_Vis_TelAllot();
            if (row != null)
            {
                if (row["F_AllotID"] != null && row["F_AllotID"].ToString() != "")
                {
                    model.F_AllotID = int.Parse(row["F_AllotID"].ToString());
                }
                if (row["F_AllotUserID"] != null && row["F_AllotUserID"].ToString() != "")
                {
                    model.F_AllotUserID = int.Parse(row["F_AllotUserID"].ToString());
                }
                if (row["F_AllotUserName"] != null)
                {
                    model.F_AllotUserName = row["F_AllotUserName"].ToString();
                }
                if (row["F_AllotZXID"] != null && row["F_AllotZXID"].ToString() != "")
                {
                    model.F_AllotZXID = int.Parse(row["F_AllotZXID"].ToString());
                }
                if (row["F_AllotZXName"] != null)
                {
                    model.F_AllotZXName = row["F_AllotZXName"].ToString();
                }
                if (row["F_HFTelID"] != null && row["F_HFTelID"].ToString() != "")
                {
                    model.F_HFTelID = int.Parse(row["F_HFTelID"].ToString());
                }
                if (row["F_state"] != null && row["F_state"].ToString() != "")
                {
                    model.F_state = int.Parse(row["F_state"].ToString());
                }
                if (row["F_CreateUserID"] != null && row["F_CreateUserID"].ToString() != "")
                {
                    model.F_CreateUserID = int.Parse(row["F_CreateUserID"].ToString());
                }
                if (row["F_CreateUserName"] != null)
                {
                    model.F_CreateUserName = row["F_CreateUserName"].ToString();
                }
                if (row["F_CreateDate"] != null && row["F_CreateDate"].ToString() != "")
                {
                    model.F_CreateDate = DateTime.Parse(row["F_CreateDate"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_AllotID,F_AllotUserID,F_AllotUserName,F_AllotZXID,F_AllotZXName,F_HFTelID,F_state,F_CreateUserID,F_CreateUserName,F_CreateDate ");
            strSql.Append(" FROM T_Vis_TelAllot ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_AllotID,F_AllotUserID,F_AllotUserName,F_AllotZXID,F_AllotZXName,F_HFTelID,F_state,F_CreateUserID,F_CreateUserName,F_CreateDate ");
            strSql.Append(" FROM T_Vis_TelAllot ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Vis_TelAllot ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_AllotID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Vis_TelAllot T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod
        /// <summary>
        /// 更新分配
        /// </summary>
        public bool UpdateFP(int id, int zxid, string zxname, int userid, string username)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Vis_TelAllot set ");
            strSql.Append("F_State=1,");
            strSql.Append("F_AllotUserID=@F_AllotUserID,");
            strSql.Append("F_AllotZXID=@F_AllotZXID,");
            strSql.Append("F_AllotZXName=@F_AllotZXName,");
            strSql.Append("F_AllotUserName=@F_AllotUserName");
            strSql.Append(" where F_AllotID=@F_AllotID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AllotUserID", SqlDbType.Int,4),
                    new SqlParameter("@F_AllotZXID", SqlDbType.Int,4),
                    new SqlParameter("@F_AllotZXName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_AllotUserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_AllotID", SqlDbType.Int,4)};

            parameters[0].Value = userid;
            parameters[1].Value = zxid;
            parameters[2].Value = zxname;
            parameters[3].Value = username;
            parameters[4].Value = id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        #endregion  ExtensionMethod
    }
}
